
#include "stdafx.h"
#include "Art.h"
#include "SpecialAvDlg.h"



IMPLEMENT_DYNAMIC(SpecialAvDlg, CDialog)

SpecialAvDlg::SpecialAvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SpecialAvDlg::IDD, pParent)
, m_compute( 0 )
{
	
}

SpecialAvDlg::~SpecialAvDlg()
{
}

BOOL SpecialAvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	refreshRButtons( );
	refreshColumns( );

	return TRUE;
}

void SpecialAvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RADIO_SUM, m_radioSum);
	DDX_Control(pDX, IDC_RADIO_DIFFERENCE, m_radioDifference);
	DDX_Control(pDX, IDC_RADIO_MEAN, m_radioMean);
	DDX_Control(pDX, IDC_RADIO_MEDIAN, m_radioMedian);
	DDX_Control(pDX, IDC_EDIT_COLUMNS, m_editColumns);
}


BEGIN_MESSAGE_MAP(SpecialAvDlg, CDialog)
	ON_BN_CLICKED(IDCANCEL, &SpecialAvDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RADIO_SUM, &SpecialAvDlg::OnBnClickedRadioSum)
	ON_BN_CLICKED(IDC_RADIO_DIFFERENCE, &SpecialAvDlg::OnBnClickedRadioDifference)
	ON_BN_CLICKED(IDC_RADIO_MEAN, &SpecialAvDlg::OnBnClickedRadioMean)
	ON_BN_CLICKED(IDC_RADIO_MEDIAN, &SpecialAvDlg::OnBnClickedRadioMedian)
	ON_BN_CLICKED(IDOK, &SpecialAvDlg::OnBnClickedOk)
END_MESSAGE_MAP()



void SpecialAvDlg::OnBnClickedCancel()
{
	refreshRButtons( );

	OnCancel();
}

void SpecialAvDlg::OnBnClickedRadioSum()
{
	m_compute = 0;
	refreshRButtons( );
}

void SpecialAvDlg::OnBnClickedRadioDifference()
{
	m_compute = 1;
	refreshRButtons( );
}

void SpecialAvDlg::OnBnClickedRadioMean()
{
	m_compute = 2;
	refreshRButtons( );
}

void SpecialAvDlg::OnBnClickedRadioMedian()
{
	m_compute = 3;
	refreshRButtons( );
}

void SpecialAvDlg::refreshRButtons( )
{
	switch( m_compute )
	{
		case 0:
			m_radioSum.SetCheck( 1 );
			m_radioDifference.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			break;
		case 1:
			m_radioSum.SetCheck( 0 );
			m_radioDifference.SetCheck( 1 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 0 );
			break;
		case 2:
			m_radioSum.SetCheck( 0 );
			m_radioDifference.SetCheck( 0 );
			m_radioMean.SetCheck( 1 );
			m_radioMedian.SetCheck( 0 );
			break;
		case 3:
			m_radioSum.SetCheck( 0 );
			m_radioDifference.SetCheck( 0 );
			m_radioMean.SetCheck( 0 );
			m_radioMedian.SetCheck( 1 );
			break;
	}
	
}

void SpecialAvDlg::refreshColumns( )
{
	CString oneColumn = _T("");
	CString targetString = _T("");
	
	for( int i=0; i < m_computedAv->columns.GetSize(); i++ )
	{
		oneColumn.Format( _T("%d"), m_computedAv->columns.GetAt( i ) );
		targetString.Append( oneColumn );

		if( i < (m_computedAv->columns.GetSize() - 1) )
		{
			targetString.Append( _T(";") );
		}
	}

	m_editColumns.SetWindowTextA( targetString );
}

void SpecialAvDlg::getComputedAv( ComputedAv *computedAv )
{
	m_computedAv = computedAv;
	m_compute = computedAv->operation;
}

void SpecialAvDlg::OnBnClickedOk()
{
	m_computedAv->operation = m_compute;

	if( extractColumns( ) )
	{
		OnOK();
	}
}

BOOL SpecialAvDlg::extractColumns( )
{
	BOOL result = TRUE;
	
	CString columnString;

	m_editColumns.GetWindowTextA( columnString );
	columnString.Remove( ' ' );

	if( ! checkUserInput( &columnString ) )
	{
		result = FALSE;
		MessageBox( _T("Please insert only digits between 0 and 9 and \";\" as separator!"), _T("Error"), MB_ICONSTOP );
	}

	m_computedAv->columns.RemoveAll();

	if( columnString.GetLength() > 0 )
	{
		int i;
		CString subString;

		while( columnString.GetLength() > 0 )
		{
			i = 0;
			subString = _T("");

			while( ( (columnString.Mid( i, 1 )).Compare( _T(";") ) != 0 ) && ( i < columnString.GetLength() ) )
			{	
				i++;
			}
			subString.Append( columnString.Left( i ) );
			columnString.Delete( 0, i+1 );

			m_computedAv->columns.Add( _ttoi((LPCTSTR) subString ) );
		}
	}

	return result;
}

BOOL SpecialAvDlg::checkUserInput( CString *columnString )
{
	BOOL result = TRUE;
	
	for( int i=0; i < columnString->GetLength(); i++ )
	{
		if
		(
			(columnString->Mid( i, 1 ) != _T(";")) && 
			(columnString->Mid( i, 1 ) != _T("0")) &&
			(columnString->Mid( i, 1 ) != _T("1")) &&
			(columnString->Mid( i, 1 ) != _T("2")) &&
			(columnString->Mid( i, 1 ) != _T("3")) &&
			(columnString->Mid( i, 1 ) != _T("4")) &&
			(columnString->Mid( i, 1 ) != _T("5")) &&
			(columnString->Mid( i, 1 ) != _T("6")) &&
			(columnString->Mid( i, 1 ) != _T("7")) &&
			(columnString->Mid( i, 1 ) != _T("8")) &&
			(columnString->Mid( i, 1 ) != _T("9"))
		)
		{
			result = FALSE;
			break;
		}
	}

	return result;

}


